508180726f20ffaafbecdf30d44f449e2f74c4b9
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43 else
44 echon="echo"
45 echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56 else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74 done
75 echo " all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87 "
88 for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115 done
116 echo " all done."
117
118 ###--------------------------------------------------------------------------
119 ### Install global configuration.
120
121 echo -n "Installing dotfile configuration:"
122 if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124 else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127 fi
128
129 ## Symlink the various dotfiles into place
130 dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el ercrc.el
133 vimrc mg zile
134 ditz-config
135 mailrc signature
136 cgrc tigrc
137 gdbinit
138 guile
139 rcrc
140 toprc
141 aspell.conf
142 lisp-init.lisp:.cmucl-init.lisp
143 lisp-init.lisp:.sbclrc
144 lisp-init.lisp:.clisprc.lisp
145 lisp-init.lisp:.eclrc
146 swank.lisp
147 dircolors colordiffrc screenrc cvsrc indent.pro"
148 [ "$xstuff" ] && dotfiles="$dotfiles
149 xinitrc xsession Xdefaults vncrc vncsession
150 fonts.conf
151 stalonetrayrc
152 putty-defaults:.putty/sessions/Default%20Settings
153 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
154 e-keybindings.cfg:.enlightenment/keybindings.cfg
155 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
156 e16-bindings:.e16/bindings.cfg"
157 echo "Installing dotfiles..."
158 for d in $dotfiles; do
159 target=.$d
160 case $d in
161 *:*) target=${d#*:} d=${d%%:*};;
162 esac
163 ft=$HOME$sub/$target
164 dir=${ft%/*}
165 mkdir -p $dir
166 ln -s $here/dot/$d $ft.new
167 mv $ft.new $ft
168 echo " $target"
169 done
170 echo " all done."
171
172 ## Substitute things which need substituting.
173 dotfilessubst="
174 gitconfig
175 pulse-default.pa.in:.pulse/default.pa"
176 echo "Installing dotfiles with substitutions..."
177 for d in $dotfilessubst; do
178 case $d in
179 *:*) target=${d#*:} d=${d%%:*};;
180 *) target=.$d d=$d.in;;
181 esac
182 ft=$HOME$sub/$target
183 dir=${ft%/*}
184 mkdir -p $dir
185 sed "
186 1i\
187 ### generated by $here/setup; do not edit!\
188
189 /@home@/ s\a\a$HOME\ag
190 /@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
191 /@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
192 " dot/$d >$ft.new
193 mv $ft.new $ft
194 echo " $target"
195 done
196 echo " all done."
197
198 ## Symlink backgrounds.
199 backgrounds="
200 jue-peek.jpg
201 medusa.jpg
202 bsg-supper.jpg
203 rayne.jpg
204 hypatia.jpg
205 noodly.jpg
206 lovelace.jpg"
207 if [ "$xstuff" ]; then
208 echo "Installing backgrounds..."
209 for b in $backgrounds; do
210 for e in enlightenment e16; do
211 dir=$HOME$sub/.$e/backgrounds
212 t=$dir/$b
213 mkdir -p $dir
214 ln -s $here/bg/$b $t.new
215 mv $t.new $t
216 done
217 echo " $b"
218 done
219 echo " all done."
220 fi
221
222 ###--------------------------------------------------------------------------
223 ### Install useful scripts included in this package.
224
225 scripts="
226 mdw-editor
227 mdw-pager
228 mdw-conf
229 mdw-build
230 emacsclient-hack
231 movemail-hack
232 aspell-hack
233 emerge-hack
234 lesspipe.sh
235 start-ssh-agent
236 svnwrap
237 hyperspec"
238 [ "$xstuff" ] && scripts="$scripts
239 xinitcmd
240 un-backslashify-selection
241 lock-screen
242 xshutdown"
243 echo "Installing scripts..."
244 mkdir -p $HOME$sub/bin
245 for s in $scripts; do
246 ft=$HOME$sub/bin/$s
247 ln -s $here/bin/$s $ft.new
248 mv $ft.new $ft
249 echo " $s"
250 done
251 echo " all done."
252
253 hacks="
254 ssh:ssh"
255 echo "Installing hacks..."
256 for h in $hacks; do
257 d=${h%%:*} h=${h#*:}
258 ft=$HOME$sub/bin/hacks/$d
259 mkdir -p $ft
260 ln -s $here/hacks/$h $ft/$h.new
261 mv $ft/$h.new $ft/$h
262 echo " $d:$h"
263 done
264 echo " all done."
265
266 ###--------------------------------------------------------------------------
267 ### Set up the Emacs config.
268
269 $echon "Finding a suitable emacs:$echoc"
270 emacs=no
271 for i in emacs22 emacs23 emacs21 emacs; do
272 if type -p >/dev/null $i; then
273 emacs=$i
274 break
275 fi
276 done
277 if [ $emacs = no ]; then
278 echo " failed."
279 emacs=:
280 else
281 echo " $emacs."
282 fi
283
284 echo "Installing Emacs packages..."
285 emacspkg="
286 make-regexp
287 ew-hols
288 mdw-gnus-patch
289 git git-blame vc-git stgit
290 quilt"
291 for elib in $emacspkg; do
292 $echon " $elib:$echoc"
293 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
294 (progn
295 (setq load-path (nconc load-path (list "~/lib/emacs")))
296 (kill-emacs (condition-case nil
297 (progn (load-library "'"$elib"'") 0)
298 (error 1))))'; then
299 echo " already installed."
300 else
301 if [ -f el/$elib.el ]; then
302 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
303 else
304 $echon " downloading$echoc"
305 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
306 fi
307 $echon " compiling$echoc"
308 (cd $HOME$sub/lib/emacs;
309 $emacs >/dev/null 2>&1 --no-site-file --batch \
310 --eval '(byte-compile-file "'"$elib.el"'")')
311 echo " done."
312 fi
313 done
314 echo " all done."
315
316 $echon "Setting up Emacs configuration:$echoc"
317 $echon " linking$echoc"
318 for f in dot-emacs.el Makefile; do
319 set -- $(echo $link | tr : ' ')
320 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
321 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
322 done
323 $echon " compiling$echoc"
324 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
325 echo " done."
326
327 ###----- That's all, folks --------------------------------------------------